# LearningHorse.jl

LearningHorse provides an easy-to-use machine learning library

## Resources
- [Documentation](https://mommawatasu.github.io/LearningHorse.jl/docs/)
- [Source code](https://github.com/MommaWatasu/Learninghorse.jl)

## Installation
LearningHorse can be installed using the Julia package manager.
From the Julia REPL, type ] to enter the Pkg REPL mode and run.
```
pkg> add LearningHorse
```

## Index

### Manual indices
```@contents
Pages = [
    "Manual/Regression.md",
    "Manual/Classification.md",
    "Manual/Preprocessing.md",
    "Manual/LossFunction.md",
    "Manual/NeuralNetwork.md"
]
Depth = 1
```
### Tutorial indices
```@contents
Pages = [
    "Tutorial/Welcome.md",
    "Tutorial/Getting_Started.md",
    "Tutorial/Preprocessing.md",
    "Tutorial/Classifiers.md",
    "Tutorial/Tree.md",
    "Tutorial/NeuralNetwork.md"
]
Depth = 1
```